#include "MacWizard.h"

MacWizard::MacWizard(){
	srand(time(0)); // Wake-up the random generator with time as seed
}

/* Too lazy to undefine */
MacWizard::~MacWizard(){
}

/* Return a valid mac addr composed of a valid OUI and a random ID */
string MacWizard::getMacAddr(){
	return getValidOui() + getRandomId();
}


/* Generates a random ID with numbers between 00 and FE */
string MacWizard::getRandomId(){
	int randNum = 0;				// Random number container
	string buf ="";
	
	for(int pos = 0; pos < 3; pos++){
		randNum = (rand()%255);			// Generate (0 <= int < 255)
    		buf.append(formatNumber(randNum));	// Format
    	
		if(pos != 2){				// Append separator
			buf += ":";
		}
	}
	return buf;
}

/* Generates a 6 bytes valid OUI between 00:00:00 and 00:20:FF */
string MacWizard::getValidOui(){
	int randNum = 0;			// Random number container
	string buf = "00:"; 			// First two bytes always 00:
	
	// Bytes 3-4
	randNum = (rand()%33);			// Generate (0 <= int < 33)
	buf.append(formatNumber(randNum));	// Append formatted number
	buf.append(":");						// Append separator
	
	// Bytes 5-6 
	randNum = (rand()%256);			// Generate (0 <= int < 256)
	buf.append(formatNumber(randNum));	// Append formatted number
	buf.append(":");			// Append separator
	
	return buf;
}

/* Simply format integers to Uppercase+Hex */
string MacWizard::formatNumber(int num){
	string buf = "";				// return buffer
	
	stream << uppercase << hex << num; 		// Hex + Uppercase + toString
	
	if(num < 16){							
		buf.append("0");
	}
	
	buf.append(stream.str());			// Append num to mac
	stream.str("");					// Flush the stream
	return buf;					// Return formatted string
}

